<?php

//error_reporting(0);

$conf = array();
include("/etc/lms/lms-subsys-advrouting.conf");

if (!$config['advrouting_enable'])
{
	exec("/usr/sbin/lms-advrouting-clear");
	exit();
}

require("/etc/lms/main.php");

define('DFTK_ROOT_PATH', "/usr/share/dftk/");
define('LMS_ROOT_PATH', "/usr/share/lms-core-api/");

require_once(LMS_ROOT_PATH."inc.php");
require_once(LMS_ROOT_PATH."hosts/inc.php");
require_once(LMS_ROOT_PATH."adsl/inc.php");

$langmgr =& new DftkDaLanguageManager();
$resultmgr =& new DftkDaTraceManager($langmgr);

$con =& new DftkLdapConnection($resultmgr);
$con->set_wrapping_parameter($config[base], "ou=Users", "ou=CommonUsers", "ou=AdminUsers", "ou=ServiceUsers");

$r =& $con->connect($config[server] , true);
if ($r->has_error())
	exit;
$r =& $con->bind($config[login], $config[passwd]);
if ($r->has_error())
	exit;

$hostmgr =& new LmsHostManager($resultmgr, $con);
$agroupmgr =& new LmsAdslGroupManager($resultmgr, $con);

define(OUTPUT_DIR, "/var/lib/lms-subsys-advrouting/");

$routers = find_routers($hostmgr);
if (count($routers)>0)
{
	//print_r($routers);
	$hostname = strtolower(exec("hostname"));
	if(test_host($hostname, $routers))
	{
		$subnets = find_subnets($routers);
		//print_r($subnets);
		list($adsls, $local_adsl) = find_adsl_info($hostname, $agroupmgr, $hostmgr, $subnets);
		//print_r($adsls);
		//print("local_adsl : ".$local_adsl."\n");
		$node_list = create_nodes($routers, $subnets);
		//print_r($node_list);
		//$path = find_path($node_list, "192.168.2.0", "192.168.3.0");
		//print_r($path);
		$conf = create_conf($hostname, $routers, $adsls, $node_list, $local_adsl);
		//print_r($conf);
		write_file("rt_tables.tmp", $conf[0]);
		write_file("advrouting.sh", $conf[1]);
	}
}

$con->disconnect();
unset($con);

if (!$config['advrouting_gen_only'])
{
	exec("/usr/sbin/lms-advrouting-clear");
	exec("cp /var/lib/lms-subsys-advrouting/rt_tables.tmp /etc/iproute2/rt_tables");
	exec("cat /etc/iproute2/rt_tables.local >> /etc/iproute2/rt_tables");
	exec("/bin/bash /var/lib/lms-subsys-advrouting/advrouting.sh");
}



function write_file($filename, $content)
{
	$fp = fopen(OUTPUT_DIR."/".$filename, 'w');
	fwrite($fp, $content);
	fclose($fp);
}

function find_routers(&$hostmgr)
{
	$tab = array();

	$r =& $hostmgr->get_list(LMS_UTYPE_SERVER, array('iphostnumber'), "(isRouter=1)");
	$nb = $r->get_result('count');
	if ($nb)
	{
		for ($i=0; $i<$nb; $i++)
		{
			$r =& $hostmgr->select_result($i);
			$ips = $r->get_result('iphostnumber');
			$hostname = $r->get_result('cn');
			$nbips = count($ips);
			if ($nbips>1)
			{
				$ipok=0;
				for ($j=0; $j<$nbips; $j++)
					if ($ips[$j]!="0.0.0.0")
						$ipok++;

				if ($ipok>1)
				{
					$tabj = 0;
					for ($j=0; $j<$nbips; $j++)
						if ($ips[$j]!="0.0.0.0")
							$tab[strtolower($hostname)][ips][$tabj++] = $ips[$j];
				}
			}
		}
	}
	else
		print("####### No Router found #######\n");

	return $tab;
}

function test_host($hostname, $tab)
{
	$isrouter = false;
	if ($tab[$hostname])
		$isrouter = true;
	else
		print("####### This host is not a router #######\n");
	
	return $isrouter;
}

function get_subnet($ip)
{
	$t = explode(".", $ip);
	$t[3] = "0";
	return implode(".", $t);
}

function find_adsl_info($hostname, &$agroupmgr, &$hostmgr, $subnets)
{
	$tab = array();
	$local_adsl = "";

	$r =& $agroupmgr->get_list(array('hostname'));
	$nb = $r->get_result('count');
	if ($nb)
	{
		for ($i=0; $i<$nb; $i++)
		{
			$r =& $agroupmgr->select_result($i);
			$aname = $r->get_result('cn');
			$r2 =& $hostmgr->find($r->get_result('servername'));
			$arips = $r2->get_result('iphostnumber');
			$arip = "";
			for ($j=0; $j<count($arips); $j++)
			{
				if ($arips[$j]!="0.0.0.0")
				{
					$arip = $arips[$j];
					break;
				}
			}
			if ($arip)
			{
				$tab2 = array();
				$tab2['name'] = $aname;
				$tab2['gtw_ip'] = $arip;
				$hostlist = $r->get_result('hostname');
				for ($j=0; $j<count($hostlist); $j++)
				{
					$r2 =& $hostmgr->find($hostlist[$j]);
					$cips = $r2->get_result('iphostnumber');
					
					if ($r2->get_result('ismobilecomputer'))
						foreach ($subnets as $k => $v)
							$tab2['clients_ips'][] = get_ip_on_subnet($cips[0], $k);
					elseif ($r2->get_result('isrouter'))
					{
						if (strtolower($hostlist[$j])==$hostname)
							$local_adsl = $aname;
						else
							for ($k=0; $k<count($cips); $k++)
								if ($cips[$k]!="0.0.0.0")
									$tab2['clients_ips'][] = $cips[$k];
					}
					else
						$tab2['clients_ips'][] = $cips[0];
				}
				$tab[] = $tab2;
			}
		}
	}
	else
		print("####### No Adsl Group found #######\n");

	return array($tab, $local_adsl);
}

function find_subnets(&$routers)
{
	$tab = array();

	foreach ($routers as $k => $v)
		for ($j=0; $j<count($routers[$k][ips]); $j++)
			$tab[get_subnet($routers[$k][ips][$j])][] = $k;
	
	foreach ($tab as $k => $v)
		$tab[$k] = array_unique($v);

	return $tab;
}

function get_ip_on_subnet($ip, $subn)
{
	$t = explode(".", $ip);
	$t2 = explode(".", $subn);
	$t2[3] = $t[3];
	return implode(".", $t2);
}

function create_nodes(&$routers, &$subnets)
{
	$tab = array();

	foreach ($subnets as $k => $v)
	{
		$tab[$k][father] = null;
		$tab[$k][f] = 0;
		$tab[$k][g] = 0;
		foreach ($v as $r)
			foreach ($routers[$r][ips] as $ip)
				$tab[$k][successors][] = array(get_subnet($ip), $r);
	}
	
	return $tab;
}

// A* DP
function find_path($node_list, $start_node, $stop_node)
{
	$P = array($start_node);
	$Q = array();
	$node = $start_node;

	while ((count($P)!=0) && ($node!=$stop_node))
	{
		$v = select_successor($node_list, $P, $Q, $node);
		if (!$v)
		{
			//print("finished with node : ".$node."\n");
			$P = array_del_val($P, $node);
			//print("P : ");
			//print_r($P);
			array_push($Q, $node);
			//print("Q : ");
			//print_r($Q);
		}
		else
		{
			$next_node = $v[0];
			//print("current node : ".$node."\n");
			//print("next node : ".$next_node."\n");
			$node_list[$next_node][g] = $node_list[$node][g]+cost($node_list, $node, $next_node);
			$node_list[$next_node][f] = $node_list[$next_node][g] + heuristique($node_list, $node, $next_node);
			$node_list[$next_node][father] = array($node, $v[1]);
			$P = P_insert($node_list, $stop_node, $P, $next_node);
			//print("P : ");
			//print_r($P);
		}
		if (count($P)!=0)
			$node = $P[0];
	}
	
	if (count($P)==0)
		return null;
	return path($node_list, $node);
}

function array_del_val($P, $node)
{
	$tab = array();

	for ($i=0; $i<count($P); $i++)
		if ($P[$i] != $node)
			$tab[] = $P[$i];

	return $tab;
}

function select_successor(&$node_list, $P, $Q, $node)
{
	$union = array_merge($P, $Q);
	$S = array();
	if (count($node_list[$node][successors])>0)
		foreach ($node_list[$node][successors] as $v)
		{
			//print ("possible successor : ".$v[0]."   g(v)=".$node_list[$v[0]][g]."   g(u)=".$node_list[$node][g]."   cost=".cost($node_list, $node, $v[0])."\n");
			if ((!in_array($v[0], $union)) || ($node_list[$v[0]][g] > $node_list[$node][g]+cost($node_list, $node, $v[0])))
				$S[] = $v;
		}

	if (count($S) == 0)
		return null;
	else
	{
		// choix du successeur
		//print("successeur : ");
		//print_r($S[0]);
		return $S[0];
	}
}

function P_insert(&$node_list, $stop_node, $P, $state)
{
	$n = -1;
	
	for ($i=0; $i<count($P); $i++)
		if (test_func($node_list, $state, $P[$i], $stop_node))
			$n = $j;
	
	if ($n<0)
		$tab = array_merge($P, array($state));
	else
		$tab = array_insert($P, $n, $state);

	return $tab;
}

function array_insert($P, $n, $state)
{
	$tab = array();
	$offset = 0;

	for ($i=0; $i<count($P)+1; $i++)
		if ($i==$n)
		{
			$tab[$i] = $state;
			$offset = -1;
		}
		else
			$tab[$i] = $P[$i+$offset];

	return $tab;
}

function test_func(&$node_list, $state1, $state2, $stop_node)
{
	$f1 = $node_list[$state1][f];
	$f2 = $node_list[$state2][f];

	if ($f1 < $f2)
		return true;
	if ($f1 > $f2)
		return false;

	$g1 = $node_list[$state1][g];
	$g2 = $node_list[$state2][g];

	if ($g1 > $g2)
		return true;
	if ($g1 < $g2)
		return false;

	if ($state1 == $stop_node)
		return true;

	return false;
}

function path(&$node_list, $node)
{
	$father = $node_list[$node][father];
	if ($father)
		return array_merge(path($node_list, $father[0]), array(array($node, $father[1])));
	else
		return array();
}

function cost(&$node_list, $node, $next_node)
{
	return 1;
}

function heuristique(&$node_list, $node, $next_node)
{
	return cost($node_list, $node, $next_node);
}

function create_conf($hostname, &$routers, &$adsls, &$node_list, $local_adsl)
{
	$route_tab = array();
	$tab = array();

	$conf ="#\n";
	$conf.="# Advanced routing configuration\n";
	$conf.="# auto-generated by LMS (lms-subsys-advrouting)\n";
	$conf.="# ".date('Y-m-d H:i:s')."\n";
	$conf.="# \n";
	$conf.="\n";
	for ($i=0; $i<count($adsls); $i++)
	{
		$aname = $adsls[$i][name];
		$conf.=($i+200)." lms_adsl_".$aname."\n";
	}
	$conf.="\n";
	$tab[] = $conf;

	$conf ="#\n";
	$conf.="# Advanced routing configuration\n";
	$conf.="# auto-generated by LMS (lms-subsys-advrouting)\n";
	$conf.="# ".date('Y-m-d H:i:s')."\n";
	$conf.="# \n";
	$conf.="\n";

	$conf.="# General routing for every ADSL\n";
	$conf.="for tab in";
	for ($i=0; $i<count($adsls); $i++)
	{
		$aname = $adsls[$i][name];
		$conf.=" \"lms_adsl_".$aname."\"";
	}
	$conf.="\n";
	$conf.="do\n";
	foreach ($node_list as $k => $v)
	{
		if (router_on_subnet($hostname, $routers, $k))
		{
			$dev = rtrim(shell_exec("ip route show | grep ".$k." | awk '{print $3}'"));
			$conf.="\t ip route add to ".$k."/24 dev ".$dev." table \$tab\n";
		}
		else
		{
			$path = get_path($node_list, $route_tab, $routers[$hostname][ips][0], $k);
			$next = get_road($hostname, $routers, $path, $routers[$hostname][ips][0], $k);

			if ($next)
				$conf.="\t ip route add to ".$k."/24 via ".$next." table \$tab\n";
		}
	}
	$conf.="done\n";
	$conf.="\n";

	for ($i=0; $i<count($adsls); $i++)
	{
		$aname = $adsls[$i][name];
		$gtw_ip = $adsls[$i][gtw_ip];
		$clients = array();
		$road = null;
		
		$clist = $adsls[$i][clients_ips];
		for ($j=0; $j<count($clist); $j++)
		{
			$src_ip = $clist[$j];
			
			if (get_subnet($src_ip) == get_subnet($gtw_ip))
			{
				if (router_on_subnet($hostname, $routers, get_subnet($gtw_ip)))
				{
					$road = $gtw_ip;
					array_push($clients, $src_ip);
				}
			}
			else
			{
				$path = get_path($node_list, $route_tab, $src_ip, $gtw_ip);
				$next = get_road($hostname, $routers, $path, $src_ip, $gtw_ip);

				if ($next)
				{
					array_push($clients, $src_ip);
					if (!$road)
						$road = $next;
				}
			}
		}

		if (count($clients) | ($aname == $local_adsl))
		{
			$conf.="# ADSL '".$aname."'\n";
			$conf.="ip route add default via ".$road." table lms_adsl_".$aname." \n";
			for ($j=0; $j<count($clients); $j++)
				$conf.="ip rule add from ".$clients[$j]." table lms_adsl_".$aname."\n";
			$conf.="\n";
		}
	}

	if ($local_adsl)
	{
		$conf.="# Local ADSL routing\n";
		$conf.="ip rule add iif lo table lms_adsl_".$local_adsl."\n";
		$conf.="\n";
	}
	
	$conf.="ip route flush cache \n";
	$conf.="\n";
	$tab[] = $conf;

	return $tab;
}

function router_on_subnet($hostname, $routers, $subn)
{
	for ($i=0; $i<count($routers[$hostname][ips]); $i++)
		if (get_subnet($routers[$hostname][ips][$i]) == $subn)
			return true;
	return false;
}

function get_path($node_list, &$route_tab, $src, $dst)
{
	$src_sn = get_subnet($src);
	$dst_sn = get_subnet($dst);

	if ($route_tab[$src_sn][$dst_sn])
		return $route_tab[$src_sn][$dst_sn];
	else if ($route_tab[$dst_sn][$src_sn])
		return array_reverse($route_tab[$dst_sn][$src_sn]);
	else
	{
		$route_tab[$src_sn][$dst_sn] = find_path($node_list, $src_sn, $dst_sn);
		return $route_tab[$src_sn][$dst_sn];
	}
}

function get_road($hostname, &$routers, &$path, $src_ip, $gtw_ip)
{
	for ($i=0; $i<count($path); $i++)
	{
		if ($path[$i][1] == $hostname)
		{
			$subn = $path[$i][0];
			$rt = $path[$i+1][1];

			for ($j=0; $j<count($routers[$rt][ips]); $j++)
				if (get_subnet($routers[$rt][ips][$j]) == $subn)
					return $routers[$rt][ips][$j];

			return $gtw_ip;
		}
	}
	
	return null;
}

?>
